#include <bits/stdc++.h>
using namespace std;

int main(){
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	int temp = t;
	string c[t];
	int j = 0;
	int brojacA = 0, brojacB = 0;
	while(t--){
		int n; cin >> n;
		long long a[n];
		long long b[n];
		vector<int> nalazi;
		bool moze = true;
		for(int i = 0; i < n; i++){
			cin >> a[i];
			if(a[i] != 0){
				brojacA++;
				nalazi.push_back(i);
			}
		}
		for(int i = 0; i < n; i++){
			cin >> b[i];
			if(b[i] != 0){
				brojacB++;
				nalazi.push_back(i);
			}
		}
		if(brojacA == 1 && brojacB == 1){
			if(abs(nalazi[0]-nalazi[1])%2 == 0){
				if(b[nalazi[1]] != a[nalazi[0]]) moze = false;
			}
			else{
				if(b[nalazi[1]] == a[nalazi[0]]) moze = false;
			}
		}
		if(moze) c[j] = "DA";
		else c[j] = "NE";
		j++;
	}
	for(int k = 0; k < temp; k++){
		cout<<c[k]<<endl;
	}
}